<?php

class articles {
	
	function popular_posts($keywords, $sources, $quantity='10') {
		
		global $db, $prefix, $time, $word;
		
		// escape strings users can input
		$keywords = mysql_real_escape_string($keywords);
		
		$timescale = $time - 86400;

		// if on the homepage get all articles
		if (empty($keywords) AND empty($sources)) {
			
			
			$get_articles = $db->query("SELECT *, s.type AS type, a.id AS id FROM ".$prefix."articles a LEFT JOIN ".$prefix."sources s ON (s.id = source_id) WHERE a.type!='trashed' AND timestamp > $timescale ORDER BY views DESC LIMIT 0, $quantity");
		}
		
		else {
			
			// get the associations of this category
			$sources = $this->get_associations($sources);
		
			$get_articles = $db->query("SELECT *, s.type AS type, a.id AS id FROM ".$prefix."articles a LEFT JOIN ".$prefix."sources s ON (s.id = source_id) WHERE a.type!='trashed' AND (timestamp > $timescale AND (MATCH (title, description) AGAINST ('$keywords' IN BOOLEAN MODE) OR source_id IN ($sources))) ORDER BY views DESC LIMIT 0, $quantity");
		
		}
		
		while ($articles = $db->fetch_array($get_articles)) {
		
			// sort out the articles favicon
			$favicon = $this->create_favicon($articles[source_id], $articles[favicon]);
		
			// url encode the title
			$title = urlencode($articles[title]);
			
			// format whether this is no follow or do follow
			if ($articles[link_type] != "Do-Follow") {
				$following = "nofollow";
			}
	
			// add this line to the array
			$string = $this->format_newsfeed_string($favicon, $title, $articles, $following);
			$output .= $string;
			
		} // end of while
		
		// if there are no articles, post one item saying so
		if (empty($string)) {
		
			$output = "<li class=\"no_articles\">$word[107]</li>";
			
		}

		return $output;
		
	}
	
	function relative_date($time) {

	$today = strtotime(date('M j, Y'));

	$reldays = ($time - $today)/86400;

	if ($reldays >= 0 && $reldays < 1) {

	return 'Today';

	} else if ($reldays >= 1 && $reldays < 2) {

	return 'Tomorrow';

	} else if ($reldays >= -1 && $reldays < 0) {

	return 'Yesterday';

	}

	if (abs($reldays) < 7) {

	if ($reldays > 0) {

	$reldays = floor($reldays);

	return 'In ' . $reldays . ' day' . ($reldays != 1 ? 's' : '');

	} else {

	$reldays = abs(floor($reldays));

	return $reldays . ' day' . ($reldays != 1 ? 's' : '') . ' ago';

	}

	}

	if (abs($reldays) < 182) {

	return date('l, j F',$time ? $time : time());

	} else {

	return date('l, j F, Y',$time ? $time : time());

	}

	}
	
	Function format_rssfeed_string($favicon, $title, $articles, $following) {
		
		global $script_url, $settings;
	
		$string = "<item>
			<title>$articles[title]</title>
			<link>$script_url/$settings[item_sub_folder]/$title</link>
			<description><![CDATA[$articles[description]]]></description> 
			</item>";
		
		return $string;
		
	}
	
	Function format_vote_output($votes){
		
		global $template, $script_url;
	
		// if the vote count is going to be a '0', use the thumbs up instead
		if (empty($votes)) {
			$vote_output = "<img src=\"$script_url/templates/$template/images/thumb_up.gif\" border=\"0\">";
		}
				
		else {
			$vote_output = $votes;
		}
		
		return $vote_output;
		
	}
	
	Function format_newsfeed_string($favicon, $title, $articles, $following, $last_title, $related_articles) {
		
		global $script_url, $settings, $word, $user_votes;
		
		$articles[posted_on] = $this->relative_date($articles[timestamp]);
		
		// find out if the user has already voted on this article
		if (in_array($articles[id], $user_votes)) {
			
			// format string with no link
			$vote_string = "$word[126]";
		}
		
		else {
			
			// provide the link
			$vote_string = "<a rel=\"nofollow\" href=\"$script_url/vote/$articles[id]\">$word[126]</a>";
				
		}
		
			// if this is a twitter feed, we don't link
			if ($articles[type] == "Twitter") {
				
				//if there are any links within this Twitter Status update, lets link to it
				$stringToArray = explode(" ", $articles[title]);
	
				foreach($stringToArray as $key=>$val){
					
					$url_validation = preg_match("/http:/", $val);
					
					if($url_validation){
						$stringToArray[$key] = "<a href=\"$val\" target=\"_new\" rel=\"$following\">$val</a>";
						break;
					}
				}
				
				$articles[title] = implode(" ", $stringToArray);
				
				$vote_output = $this->format_vote_output($articles[votes]);
				
				$string = "<li class=\"tweet\"><span class=\"vote\">$vote_output<small> $vote_string </small></span> $articles[title] <small> $favicon<a href=\"$articles[site_url]\" target=\"_new\" rel=\"$following\">$articles[name]</a> - $articles[posted_on]</small></li>";	
				
			}
			
			else {
				
				$vote_output = $this->format_vote_output($articles[votes]);
			
				$string = "<li><span class=\"vote\">$vote_output<small>$vote_string </small></span> <a href=\"$script_url/$settings[item_sub_folder]/$title\">$articles[title]</a> <small> $favicon <a href=\"$articles[site_url]\" target=\"_new\" rel=\"$following\">$articles[name]</a>  - $articles[posted_on]</small> $related_articles</li>";
				
			}
		
		
		
		return $string;
		
	}
	
	Function update_viewcount($id) {
		
		global $db, $prefix;
		
		// update the last crawled time
		$db->query("UPDATE ".$prefix."articles SET views=views+1 WHERE id=$id");
		
	}
	
	Function get_associations($cat_ids) {
		
		global $db, $prefix;
		
		// get the associations of this category
		$get_associations = $db->query("SELECT * FROM ".$prefix."associations WHERE cat_id IN ($cat_ids)");
		while ($associations = $db->fetch_array($get_associations)) {
			
			// create an array of the sources needed
			$sources[] = $associations[source_id];
			
		}
		
		if (empty($sources)) { 
			
			$sources = "0"; 
			
		}
		
		else {
			
			$sources = implode(", ", $sources);
			
		}

		return $sources;
		
	}
	
	Function create_favicon($source_id, $favicon) {
		
		global $script_url, $template;
		
		if(empty($favicon)) {
			
			$favicon = "<img src=\"$script_url/templates/$template/images/default_favicon.gif\" height=\"16\" width=\"16\"/>";
	
		}
	
		else {
	
			$favicon = "<img src=\"$script_url/favicons/$source_id\" height=\"16\" width=\"16\"/>";

		}
		
		return $favicon;
		
	}
	
	Function get_all_articles($start, $end) {
		
		global $db, $prefix;
		
		// if sources is empty, just add a 0 so no error gets sent
		
		$get_articles = $db->query("SELECT *, a.id AS id, s.type AS type FROM ".$prefix."articles a LEFT JOIN ".$prefix."sources s ON (s.id = source_id) WHERE a.type!='trashed' ORDER BY a.timestamp DESC LIMIT $start, $end");	
		
		return $get_articles;
		
	}
	
	Function compile_article_query($keywords, $sources, $start, $end) {
		
		global $db, $prefix;
		
		// if sources is empty, just add a 0 so no error gets sent
		
		$get_articles = $db->query("SELECT *, a.id AS id, s.type AS type, a.title AS title, a.description AS description
					   FROM ".$prefix."articles a
					   LEFT JOIN ".$prefix."sources s ON (s.id = source_id)
						
					   WHERE a.type!='trashed' AND (MATCH (a.title, a.description) AGAINST ('$keywords' IN BOOLEAN MODE) OR a.source_id IN ($sources))
					   ORDER BY a.timestamp DESC LIMIT $start, $end");	
		
		return $get_articles;
		
	}
	
	Function pagination($page, $tpp) {
	
		if ($page == '1') {
			$start_row = '0';	
		}
		
		else {
			$start_row = $page * ($tpp);
		}
		
		return $start_row;
		
	}
	
	Function get_single_article($title) {
	
		global $db, $prefix;
		
		$get_article = $db->query("SELECT *, a.id AS id, a.url AS url, s.url AS source_url FROM ".$prefix."articles a LEFT JOIN ".$prefix."sources s ON s.id = source_id WHERE title='$title'");
		$article = $db->fetch_array($get_article);
		
		$article[posted_on] = $this->relative_date($article[timestamp]);
		
		// chop the article description down to size
		$article[description] = substr($article[description], 0, 300);
		
		return $article;
	
	}
	
	Function get_articles($keywords, $cats, $num_articles, $order, $type, $format) {
						
		// globalize the database class to make it available throughout the whole script
		global $db, $time, $settings, $script_url, $page, $prefix, $cache, $word, $id;
		
		$keywords = mysql_real_escape_string($keywords);
		
		// if we're on the homepage and this is a request for the feed, go no further
		
		if ($format == 'feed' AND empty($id)) {
		
			$get_articles = $this->get_all_articles(0, $settings[tpp]);
				
			while ($articles = $db->fetch_array($get_articles)) {
			
				// url encode the title
				$title = urlencode($articles[title]);
				$articles[title] = htmlspecialchars($articles[title], ENT_QUOTES);
				$articles[description] = htmlspecialchars($articles[description], ENT_QUOTES);
							
				$output[feed] .= $this->format_rssfeed_string($favicon, $title, $articles, $following);	
			
			}
			
		} // end of if
		
		else {
		
			// get the timesclases
			$scales = $cache[timescales] = unserialize(base64_decode($cache[timescales]));	
			
			// pagination functionality
			$start_row = $this->pagination("$page", "$settings[tpp]");
			
			// count how many timescales have come through sir squire
			$scales_count = count($scales);
			
			// add 'older news' to the end of the timescale
			$scales[$scales_count][title] = $word[98];
			$scales[$scales_count][timescale] = "99999999999";
			$scales[$scales_count][output] = "<li class=\"timescale\">$word[98]</li>";
			
			// account for the older news added timescale to capture anything out of the defined timescales
			$scales_count++;
			
			// if this is a search for related articles then we do a different type of query
			// the related articles are the ones displayed on the article individual pages
			if ($type == "related") {
			
				$get_articles = $db->query("SELECT *, a.id AS id, MATCH (title, description) AGAINST ('$keywords') AS score FROM ".$prefix."articles a LEFT JOIN ".$prefix."sources s ON (s.id = source_id) WHERE a.type!='trashed' AND MATCH (title, description) AGAINST ('$keywords') AND title!='$keywords' HAVING score > 7 ORDER BY a.timestamp DESC LIMIT $start_row, $num_articles");
			
			}
			
			else {
			
				// if there are no keywords passed then get all articles broken down by root categories
				
				if (empty($id)) {
					
					$get_articles = $this->get_all_articles($start_row, $num_articles);
				}
			
				// else use keyword list to get articles
				else {
					
					// get the associations of this category 
					$sources = $this->get_associations($cats);
					
					$get_articles = $this->compile_article_query($keywords, $sources, $start_row, $num_articles);	
				}
			
			}
			
				// create a variable to store the amount of articles
				$article_count = '0';
			
				while ($articles = $db->fetch_array($get_articles)) {
					
					
					// dependent on format
					if ($format == 'feed') {
						
						// url encode the title
						$title = urlencode($articles[title]);
						$articles[title] = htmlspecialchars($articles[title], ENT_QUOTES);
						$articles[description] = htmlspecialchars($articles[description], ENT_QUOTES);
							
						$output[feed] .= $this->format_rssfeed_string($favicon, $title, $articles, $following);	
								
					}
					
					else{
			
						$article_count++;
		
						// create the counter so we can iterate through the timescales array whilst we're here
						// only using this because there's no way of getting to the $count variable within the actual for loop
						$mycounter = '0';
		
						// loops through all of the array as counted in $scales_count
						for($count=0; $count <= $scales_count; $count++) {
		
						
							$timescale = $scales[$mycounter][timescale]; 
						
							// take the timescale away from the current timestamp - lets go back in time! woo!
							$time_to_compare = $time - $timescale;
						
							if ($articles[timestamp] > $time_to_compare) {
						
								echo $scales[$mycounter][name];
						
							}
						
							// if it's newer than we are than it must have been within this timeframe!
							if ($articles[timestamp] > $time_to_compare) {
						
								// sort out the articles favicon
								$favicon = $this->create_favicon($articles[source_id], $articles[favicon]);
							
						// store the phrase we'll use to find related articles
						$phrase = "$articles[title]";
						$related_phrase = addslashes($phrase);
						
						// get related articles to this entry
						$get_related = $db->query("SELECT *, a.id AS id, MATCH (title, description) AGAINST ('$related_phrase') AS score FROM ".$prefix."articles a LEFT JOIN ".$prefix."sources s ON (s.id = source_id) WHERE a.type!='trashed' AND MATCH (title, description) AGAINST ('$related_phrase') AND a.id!='$articles[id]' HAVING score > 7 ORDER BY a.timestamp DESC LIMIT 0, 3");
					
						while ($related = $db->fetch_array($get_related)) {
							
							// sort out the articles favicon
							$related_favicon = $this->create_favicon($related[source_id], $related[favicon]);
							
							// URL encode the title tag							
							$related_title = urlencode($related[title]);
							
													// format whether this is no follow or do follow
							if ($related[link_type] != "Do-Follow") {
								$related_following = "nofollow";
							}
							else {
								$related_following = "";
							}
						
							$related_articles .= "<li> $related_favicon <a href=\"$script_url/$settings[item_sub_folder]/$related_title\">$related[title]</a> - <small> <a href=\"$related[site_url]\" target=\"_new\" rel=\"$related_following\">$related[name]</a></small></li>";
							
						}
						
						//if there are any related articles, lets put them in a list item
						if ($related_articles) {
							$related_articles = '<ul class=related>' . "$related_articles" . '</ul>';
						}
						
						
							
								// url encode the title
								$title = urlencode($articles[title]);
							
								// format whether this is no follow or do follow
								if ($articles[link_type] != "Do-Follow") {
									$following = "nofollow";
								}
						
								// add this line to the array
									
									
								$string = $this->format_newsfeed_string($favicon, $title, $articles, $following, '', $related_articles);
		
								$related_articles="";
								
								$scales[$mycounter][output] .= $string;
								
								$scales[$mycounter][populated] = true;
							
								// if we've run through this then let's exit it so we can mnove on to the next
								// nothing else to see here!
							
								break;
							
							}	// end of if yeah
						
							$mycounter++;
						
						} // end of forrrrrrrrrr
						
	
				} // end of while
			
			} // end of else not on homepage
			
			// now lets create an array that only contains the current timescales and data
			$mycounter = '0';
	
			// loops through all of the array as counted in $scales_count
			for($counter=0; $counter <= $scales_count; $counter++) {
				
				if ($scales[$mycounter][populated]) {
					
					$output[newsfeed] .= $scales[$mycounter][output];
						
				}
				
				$mycounter++;
					
			}
			
			
			// if there are no articles, post one item saying so
			if ($article_count == 0 AND !empty($id)) {
			
				$output[newsfeed] = "<li class=\"no_articles\">$word[79]</li>";
				
			}
			
			//if there are no articles and we're on the homepage, output the instruction message to read documentation
			elseif($article_count == 0 AND empty($id)) {
				
				$output[newsfeed] = "<li class=\"no_articles\">$word[169]</li><a href='$script_url/update'>$script_url/update</a></small>";
				
			}
	
			// put the article count into the output variable for return
			$output[article_count] = $article_count;
		
		} // end of else
		
		return $output;
		
	} // end of functional
	
}

?>
