<?php

// start a new user session
session_start();

require "classes/class_articles.php";
require "classes/categories.php";


// store this page as the last page visited

$_SESSION['lastpage'] = $_SERVER['REQUEST_URI'];

// if it's a search, lets figure out the keywords for the search

if ($location == "search") {
	
	// if there's no value in the POST we're on a page from the search
	if ($_POST['search']) {
	
		$id = $_POST['search'];
		
		// strip out any potential harmful code
		$id = strip_tags($id);
		
		$searchphrase = $id;

		
	}
	
	else {
		
		// else we'll need to decode the URL
		$id = urldecode($id);
		$searchphrase = $id;


	}
	
	//create a default value to make visible in the search box
	$search_box_value = htmlspecialchars($id);
	
	$current_category[combined_child_keywords] = $searchphrase;
	$current_category[combined_child_ids] = '0';
	$current_category[name] = "$id";
	$breadcrumbs[title_text] = "$word[110]: &quot;$id&quot; | $settings[site_name]";
	$breadcrumbs[on_page] = "-> $word[109]";
	
	// encode the id for the URL
	$encoded_id = urlencode($id);
	$current_category[path] = "search/$encoded_id";
	
}

// else we're on the homepage or in a category

else {
	
	// get the child categories
	$categories = new categories();
	
	// if this is a user feed, lets treat the keyword retrieval sligtly differently
	if ($location == "user-feed") {
		
		// get the user id
		$users_id = $user->get_user($feed_belongs_to);
		
		// decode the name
		$id = urldecode($id);
		
		// get the keywords from the feed using $feed_belongs_to and $id
		$userfeed = $user->get_feed($users_id[id], $id);

		// populate the keywords into the usual query supplied to the categories
		$current_category[combined_child_keywords] = addslashes($userfeed[keywords]);
		$current_category[combined_child_ids] = "0";
		
		// creat the path back to this users feed
		$current_category[path] = "user-feed/$feed_belongs_to/$id";
		
		// assign the category name for the breadcrumb trail
		$current_category[name] = $userfeed[name];
		
	}
	
	else {
		
		// get the root categories ready to form the navigational aspects
		$get_root_categories = $categories->get_root_categories();
		$root_categories = $categories->structure_categories($get_root_categories);
		
		// get the current category info
		$get_current_category = $categories->get_current_category($id);
		$current_category = $db->fetch_array($get_current_category);
		
		//add slashes
		$current_category[combined_child_keywords] = addslashes($current_category[combined_child_keywords]);
		
		// if we can't find the category and an ID is present - 301 redirect to homepage
		if (empty($current_category) AND $id) {
		
			// output 301 redirect
			Header("HTTP/1.1 301 Moved Permanently");
			Header("Location: $script_url"); 
		
		}
		
	}
	
	// create the breadcrumb trail for the category
	$breadcrumbs = $categories->create_category_breadcrumb($current_category[name], $current_category[parent_associations]);

} // end of else homepage or category (not a search)

// righty we've got them yarrr, right now lets go through all the articles like you know?

$article = new articles();

$output = $article->get_articles(stripslashes($current_category[combined_child_keywords]), $current_category[combined_child_ids], $settings[tpp], '', '', $format);

// get the popular posts
$popular_posts = $article->popular_posts(stripslashes($current_category[combined_child_keywords]), $current_category[combined_child_ids], $settings[pppp]);

// pagination

// the previous page
$ppage = $page - 1;

// the next page
$npage = $page + 1;

if ($page AND $page != '1') { 

	if ($id) { 
	
		// if the previous page=1, just send back to back and page 1 will load
		// also stops duplicate content issue
		if ($ppage == '1') {

			$previous_page = "<li id='previouspage'>< <a href=\"$script_url/$current_category[path]\">$word[1]</a></li>";

		}
		
		else {
		
			$previous_page = "<li id='previouspage'>< <a href=\"$script_url/$current_category[path]/page-$ppage\">$word[1]</a></li>";

		}

	}
	
	else {
	
		
		// if the previous page=1, just send back to back and page 1 will load
		// also stops duplicate content issue
		if ($ppage == '1') {
	
			$previous_page = "<li id='previouspage'>< <a href=\"$script_url\">$word[1]</a></li>";
	
		}
		
		else {
	
			$previous_page = "<li id='previouspage'>< <a href=\"$script_url/page-$ppage\">$word[1]</a></li>";
	
		}
	
	}

}

else {

	$npage = '2';
	
}

// if there isn't enough articles to fill the current page, don't provide a link to the next

if ($output[article_count] >= $settings[tpp]) {

	if ($id) {

		$next_page = "<li id='nextpage'><a href=\"$script_url/$current_category[path]/page-$npage\">$word[2]</a> ></li>";
		
	} 
	
	else {
	
		$next_page = "<li id='nextpage'><a href=\"$script_url/page-$npage\">$word[2]</a> ></li>";	
	
	}

}

// assign page specific template variables

// page heading
// if we're in a category, the heading should be named after the category
if ($current_category) {
	$page_heading = "<strong>$current_category[name]</strong> $word[4]";
	
	// also create the page title
	$title = $breadcrumbs[title_text];
	
}

// else we'll have to come up with a different one for the homepage
else {
	$current_category[description] = $settings[description];
	$page_heading = "$word[4]";
	
	// also create the page title
	$title = $settings[site_name];
	
}

if ($format == "feed") {
	
	header("Content-Type: application/xml; charset=utf-8");
	
	// make sure the title and description encoding work seamlessly
	$title = htmlspecialchars($title, ENT_QUOTES);
	$current_category[description] = htmlspecialchars($current_category[description], ENT_QUOTES);
	
	$feed_output .= '<?xml version="1.0" encoding="utf-8" ?> 
		    <rss version="2.0"> 
			<channel> 
			    <title>'. $title .'</title> 
				<link>'.$script_url.'/'.$current_category[path].'</link> 
				<description>'. $current_category[description] .'</description>';
				
	$feed_output .= $output[feed];
	
	$feed_output .= "</channel> 
	                </rss>";
			
	echo $feed_output;
	
}

else {

	$build_template->create_header($title, $current_category[description], '', $breadcrumbs[on_page]);
	
	include "templates/$template/left_nav.html";
	
	include "templates/$template/index.html";
	
	include "templates/$template/sidebar.html";
	
	include "templates/$template/footer.html";
	
}

?>