<?php

error_reporting(0);

// include the language file
include "languages/english.php";

// get the login details for the database

include "settings/credentials.php";

// include the correct database class file

include "database/$database_type.php";

$db = new database();

// connect to the database

$db->connect($hostname, $username, $password);

// select the database

$db->select_db($database_name);

// sort out php magic quotes
if (get_magic_quotes_gpc()) {
    $process = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
    while (list($key, $val) = each($process)) {
        foreach ($val as $k => $v) {
            unset($process[$key][$k]);
            if (is_array($v)) {
                $process[$key][stripslashes($k)] = $v;
                $process[] = &$process[$key][stripslashes($k)];
            } else {
                $process[$key][stripslashes($k)] = stripslashes($v);
            }
        }
    }
    unset($process);
}

// get the custom settings from the database
$get_settings = $db->query("SELECT * FROM ".$prefix."settings WHERE id='1'");
$settings = $db->fetch_array($get_settings);

$template = $settings[default_template];

// get the cache
$get_cache = $db->query("SELECT * FROM ".$prefix."cache");
while ($cached_data = $db->fetch_array($get_cache)){
	$cache[$cached_data[area]] = $cached_data[content];
}

// define some varaibles for the template
$navigation = $cache[navigation_list];

// include globally needed classes

include "classes/template.php";
$build_template = new templates();

///////////////////////////////////////////////////////////////////////
//	SEF URL's
///////////////////////////////////////////////////////////////////////

// define the site root and folder path for linking to stylesheets etc

$root = $settings[root_url];
$folder = $settings[folder_path];
// if there's a folder, add a slash and a folder, else leave slash

if ($folder) {

	$script_url = "$root". "/" . "$folder";

}

else {
	
	$script_url = "$root" . "$folder";
	
}


// get the document path so we can start manipulating it
$path = $_SERVER['REQUEST_URI'];

// explode the results into an array
$sef_url = explode("/", $path);

// remove any portions of the array that are part of the document path
// these bits are not actual category calls so need to be removed

// first create an array of the actual folder structure
$folder = explode("/", $folder);

$sef_url = array_diff($sef_url, $folder);
$sef_url = array_filter($sef_url);

if (in_array("$settings[item_sub_folder]", $sef_url)) {

	$location="article";
	$sub_folder = $settings[item_sub_folder];
	$id = end($sef_url);

	//if there's no ID, 301 redirect this none existent article to the homepage to flow potential link juice back in
	if (empty($id) OR ($id==$sub_folder)) {
		// output 301 redirect
		Header("HTTP/1.1 301 Moved Permanently");
		Header("Location: $script_url");
	}

}

elseif(in_array("favicons", $sef_url)) {

	$location="favicons";
	$id = end($sef_url);

}

elseif(in_array("vote", $sef_url)) {

	$location="vote";
	$id = end($sef_url);

}


elseif(in_array("comment", $sef_url)) {

	$location="comment";
	$id = end($sef_url);

}

elseif(in_array("register", $sef_url)) {

	$location="register";
	$id = end($sef_url);

}

elseif(in_array("login", $sef_url)) {

	$location="login";
	$id = end($sef_url);

}

elseif(in_array("logout", $sef_url)) {

	$location="logout";
	$id = end($sef_url);

}

elseif(in_array("profile", $sef_url)) {

	$location="profile";
	$id = end($sef_url);

}

elseif(in_array("create", $sef_url)) {

	$location="create";
	$id = end($sef_url);

}

elseif(in_array("edit", $sef_url)) {

	$location="edit";
	$id = end($sef_url);

}

elseif(in_array("delete", $sef_url)) {
	
	$location = "edit";
	$id = end($sef_url);
	$_POST['action'] = "delete";
	
}

elseif(in_array("feed", $sef_url)) {
	
	$location = "";
	$id = implode("/", $sef_url);
	
	//replace feed url if in category
	$id = str_replace("feed/", "", $id);
	
	// replace feed url part if on homepage
	// only difference being the '/' if on homepage, it's not there
	$id = str_replace("feed", "", $id);

	$format = "feed";
	
}

elseif(in_array("search", $sef_url)) {
	
	// if there's a page, save it in the page variable
	$pos = strpos(end($sef_url), "page-");

	// The !== operator can also be used.  Using != would not work as expected
	// because the position of 'a' is 0. The statement (0 != false) evaluates 
	// to false.
	if ($pos !== false) {
	
		$page = str_replace("page-", "", end($sef_url));
		array_pop($sef_url);
	}
	
	else {
	
		$page = 1;
	
	}

	// reset the array pointer
	reset($sef_url);

	// if the first part of the array = search then no data was input
	// so in that case we 301 to homepage
	if (current($sef_url) == 'search' AND !next($sef_url) AND empty($_POST[search])) {
		
		// output 301 redirect
		Header("HTTP/1.1 301 Moved Permanently");
		Header("Location: $script_url");
		
	}

	$id = end($sef_url);

	$location="search";


}

elseif(in_array("sitemap.xml", $sef_url)) {
	$location = "xmlsitemap";
}

elseif(in_array("update", $sef_url)) {

	$location="update";	

}

elseif (in_array("user-feed", $sef_url)) {
	
	// if there's a page, save it in the page variable
	$pos = strpos(end($sef_url), "page-");

	// The !== operator can also be used.  Using != would not work as expected
	// because the position of 'a' is 0. The statement (0 != false) evaluates 
	// to false.
	if ($pos !== false) {
	
		$page = str_replace("page-", "", end($sef_url));
		array_pop($sef_url);
	}
	
	else {
	
		$page = 1;
	
	}

	$location = "user-feed";
	$id = end($sef_url);
	$feed_belongs_to = prev($sef_url);
	
}

else {

	// if there's a page, save it in the page variable
	$pos = strpos(end($sef_url), "page-");

	// The !== operator can also be used.  Using != would not work as expected
	// because the position of 'a' is 0. The statement (0 != false) evaluates 
	// to false.
	if ($pos !== false) {
	
		$page = str_replace("page-", "", end($sef_url));
		array_pop($sef_url);
	}
	
	else {
	
		$page = 1;
	
	}

	$location = "";
	$id = implode("/", $sef_url);

}

// escape any possible harmful code from the id
$id = strip_tags($id);

// the below array is a breakdown of the files that we'll need
$locations = array(
		 "" => "main.php",
		 "search" => "main.php",
		"update" => "update.php",
		"login" => "login.php",
		"register" => "register.php",
		"article" => "article.php",
		"favicons" => "favicons.php",
		"xmlsitemap" => "feed.php",
		"logout" => "logout.php",
		"vote" => "vote.php",
		"comment" => "comment.php",
		"profile" => "profile.php",
		"create" => "create.php",
		"edit" => "edit.php",
		"user-feed" => "main.php"
		);

// assign the time to a variable to make it globally available throught the script
$time = time();

function read_header($ch, $header)
{
    global $modified;
    $length = strlen($header);
    if(strstr($header, "Last-Modified:"))
    {
        $modified = substr($header, 15);
    }
    return $length;
}

function last_mod($remote_file)
{
    global $modified;
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $remote_file);
    curl_setopt($ch, CURLOPT_HEADER, 1);
    curl_setopt($ch, CURLOPT_NOBODY, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HEADERFUNCTION, 'read_header');

    $headers = curl_exec ($ch);
    curl_close ($ch);
    return $modified;
}

// make a call to the appropriate file based on the information passed to the array as formatted above
include "includes/$locations[$location]";

?>